%% CONFIGURATION FILE OF BRANIN FUNCTION
% variables starting with majuscule are REQUIRED
% variables needed in value function or eval function must be defined as global (e.g. outfile)

% dimension of problem
Dim = 2;

% bound for variables
% lower bound
lb = [ -5 0 ];
% upper bound
ub = [ 10 15 ];

Domain = [ lb' ub' ];

% Regression function
regr = @regpoly0;

% put 1, if solution must be inside bounds
% put 0, if solution could be also outside bounds
Return_to_domain = 1;

% name
Name = 'Branin';

%name of matlab function
F = @Branin;

%name of matlab script specifying what should happen when new beter solution is found, the script can be empty
Feval = @Branineval;

% optimum - if not know, type some desired value, NOT REQUIRED
opt = 0.39789;

% precission is necessary for using CERAF strategy
Prec = 0.01*opt;

% name of outfile

global outfile
outfile = sprintf('%s_001.out', Name );
runi = 1;
f = fopen(outfile, 'r');
while f~=-1
    fclose( f );
    runi = runi+1;
    outfile = sprintf('%s_%03d.out', Name, runi );
    f = fopen(outfile, 'r');
end


%% author: Anicka Kucerova, Czech Technical University in Prague
%% version 0.0.4
%% 17 Sep 2013
